import random

import numpy as np
import cv2
from matplotlib import pyplot as plt
import copy

import yang.myutil as myutil


def visual_different_people_gaze_data():
    plt.figure()
    for p in range(30):
        path = "/home/simula/Pro/textured_mesh_saliency/fixation/zy/" + str(p) + '.txt'
        file = open(path, 'r')
        all_lines = file.readlines()
        gaze_ball_position_lists = []
        # 将字符串数值化
        for line in all_lines:
            numbers = line.split(',')
            gaze_ball_position = np.array([numbers[0], numbers[1], numbers[2]], np.float)
            gaze_ball_position_lists.append(gaze_ball_position)
        gaze_ball_position_lists = np.array(gaze_ball_position_lists)
        # 将unity坐标系转换成opencv坐标系
        for i in range(len(gaze_ball_position_lists)):
            gaze_ball_position_lists[i] += np.array([0.5, -0.5, 0])
            # right_eyes[i] += np.array([0.5, -0.5, 0])
            gaze_ball_position_lists[i][1] *= -1

        pic_path = "/home/simula/Pro/textured_mesh_saliency/fixation/all/" + str(p) + '.png'
        print(pic_path, 'length = ', len(gaze_ball_position_lists))
        imga = cv2.imread(pic_path)
        imga = cv2.resize(imga, (512, 512), 0, 0)
        img = imga
        # img = np.zeros(512 * 512 * 3).reshape([512, 512, 3])
        # img = np.array(img, np.uint8)

        dist = 1 / 512
        for i in range(len(gaze_ball_position_lists)):
            gaze_x = int(gaze_ball_position_lists[i][0] / dist)
            gaze_y = int(gaze_ball_position_lists[i][1] / dist) + 30  # 将偏上的点挪下来
            if 0 <= gaze_x < 512 and 0 <= gaze_y < 512:
                cv2.circle(img, (gaze_x, gaze_y), 20, (213, 0, 0), -1)

        plt.subplot(5, 6, p + 1)
        plt.imshow(img)

    plt.axis('off')
    plt.show()

# put all gaze data to one img
def all_gaze_data_to_one():
    fig = plt.figure(figsize=(400, 400))
    start, end = 6, 8
    for p in range(start, end):
        pic_path = "/home/simula/Pro/textured_mesh_saliency/fixation/all/" + str(p) + '.png'
        imga = cv2.imread(pic_path)
        imga = cv2.resize(imga, (512, 512), 0, 0)
        img = imga
        name = ['hlg', 'llxj', 'lxj', 'sxy', 'ybxz', 'zy', 'zy2']
        count = 0
        for i in name:
            # gaze_point_list = []

            count += 1
            # imgt = copy.deepcopy(img)
            imgt = np.zeros(img.shape, dtype=np.uint8)
            txt_path = "/home/simula/Pro/textured_mesh_saliency/fixation/" + i + '/' + str(p) + '.txt'

            gaze_point_list, imgt = process_gaze_data(txt_path, imgt)
            color = (random.randint(0, 255), random.randint(0, 255), random.randint(0, 255))

            for i in gaze_point_list:
                img = put_mask(img, i[0], i[1], 2, color)

            # x, y = gaze_point_list[:, 0], gaze_point_list[:, 1]
            # heatmap, xedges, yedges = np.histogram2d(x, y, bins=(512, 512))
            # extent = [xedges[0], xedges[-1], yedges[0], yedges[-1]]

            plt.subplot(end - start, 7, (p-6)*7+count)
            plt.imshow(img)
            # plt.imshow(heatmap.T, extent=extent, origin='lower')

    # plt.axis('off')
    plt.show()

def process_gaze_data(txt_path, imgt):
    gaze_point_list = []

    file = open(txt_path, 'r')
    all_lines = file.readlines()
    gaze_ball_position_lists = []
    # 将字符串数值化
    for line in all_lines:
        numbers = line.split(',')
        gaze_ball_position = np.array([numbers[0], numbers[1], numbers[2]], np.float)
        gaze_ball_position_lists.append(gaze_ball_position)
    gaze_ball_position_lists = np.array(gaze_ball_position_lists)

    # 将unity坐标系转换成opencv坐标系
    data_lines = int(len(gaze_ball_position_lists) / 3)
    for k in range(data_lines * 0, data_lines * 2):
        # 坐标系挪到左上角
        gaze_ball_position_lists[k] += np.array([0.5, -0.5, 0])
        # y轴翻转得到opencv坐标系
        gaze_ball_position_lists[k][1] *= -1

    # 将观察者的数据显示到图像上
    dist = 1 / 512
    color = (random.randint(0, 255), random.randint(0, 255), random.randint(0, 255))

    for k in range(data_lines * 0, data_lines * 2):
        gaze_x = int(gaze_ball_position_lists[k][0] / dist)
        gaze_y = int(gaze_ball_position_lists[k][1] / dist)  # 将偏上的点挪下来
        gaze_y += 18
        if 0 <= gaze_x < 512 and 0 <= gaze_y < 512:
            # cv2.circle(imgt, (gaze_x, gaze_y), 12, (213, 0, 0), -1)
            imgt = put_mask(imgt, gaze_x, gaze_y, 5, color)
            gaze_point_list.append((gaze_x, gaze_y))

    gaze_point_list = np.array(gaze_point_list)

    return gaze_point_list, imgt

# 设定一个colormap，然后从中心开始向外扩散，不断的减低颜色，扩散的范围为注视点停留时间
# 在这里为相同的注视点的重复个数
def my_circle(img, center, radius, color):
    center_x, center_y = center
    # traverse rectangle area
    for x in range(center_x - radius, center_x + radius):
        for y in range(center_y - radius, center_y + radius):
            # 这里对半径进行划分，不同层级设定不同的颜色，层级指距离中心的距离的分层
            if (x-center_x)*(x-center_x) + (y-center_y)*(y-center_y) <= radius*radius:
                img[x][y] = color
    return

def put_mask(image, x, y, radius, color):

    # 3.画出mask
    zeros1 = np.zeros((image.shape), dtype=np.uint8)
    zeros_mask1 = cv2.circle(zeros1, (x, y), radius, color, thickness=-1) #thickness=-1 表示矩形框内颜色填充
    zeros_mask = np.array(zeros_mask1)

    # alpha 为第一张图片的透明度
    alpha = 1
    # beta 为第二张图片的透明度
    beta = 0.5
    gamma = 0
    # cv2.addWeighted 将原始图片与 mask 融合
    image = cv2.addWeighted(image, alpha, zeros_mask, beta, gamma)
    return image


def gazepath():
    p = 7
    txt_path = "/home/simula/Pro/textured_mesh_saliency/fixation/" + "zy" + '/' + str(p) + '.txt'
    pic_path = "/home/simula/Pro/textured_mesh_saliency/fixation/all/" + str(p) + '.png'
    img = cv2.imread(pic_path)
    img = cv2.resize(img, (512, 512), 0, 0)

    gaze_point_list, img = process_gaze_data(txt_path, img)
    start = 0
    pre_point = gaze_point_list[0]
    count = 1
    # 对gazepointlist去重，然后画出路径
    for index in range(2, len(gaze_point_list)):
        cur_point = gaze_point_list[index]
        pre_l = myutil.norm(pre_point)
        cur_l = myutil.norm(cur_point)
        if pre_l == cur_l:
            count += 1
        else:
            color = (random.randint(0, 255), random.randint(0, 255), random.randint(0, 255))
            print(count)
            if count > 10:
                cv2.putText(img, str(start), tuple(pre_point), cv2.FONT_HERSHEY_SIMPLEX, 0.5, color, 2)
                start += 1
            cv2.line(img, tuple(pre_point), tuple(cur_point), (0, 255, 0), 2)
            img = put_mask(img, pre_point[0], pre_point[1], count, color)
            pre_point = cur_point
            count = 1

    plt.imshow(img)
    plt.show()


def heatmap_gaussian():
    import matplotlib.cm as cm
    from scipy.ndimage.filters import gaussian_filter

    def myplot(x, y, s, bins=1000):
        heatmap, xedges, yedges = np.histogram2d(x, y, bins=bins)
        heatmap = gaussian_filter(heatmap, sigma=s)
        extent = [xedges[0], xedges[-1], yedges[0], yedges[-1]]
        return heatmap.T, extent

    # figu = plt.figure(figsize=(512, 512))

    p = 7
    txt_path = "/home/simula/Pro/textured_mesh_saliency/fixation/" + "zy" + '/' + str(p) + '.txt'
    pic_path = "/home/simula/Pro/textured_mesh_saliency/fixation/all/" + str(p) + '.png'
    img = cv2.imread(pic_path)
    img = cv2.resize(img, (512, 512), 0, 0)
    image = cv2.imread(pic_path)
    image = cv2.resize(image, (512, 512), 0, 0)

    gaze_point_list, img = process_gaze_data(txt_path, img)
    # Generate some test data
    x = gaze_point_list[:, 0]
    y = gaze_point_list[:, 1]
    sigmas = [0, 16, 32, 64]
    for s in sigmas: # zip for combine two list
        if s == 0:
            # 如果是0就画出点就好
            imgt = np.zeros(image.shape, dtype=np.uint8)
            for i in range(len(x)):
                cv2.circle(imgt, (x[i], y[i]), 12, (213, 0, 0), -1)
            plt.subplot(2, 2, 1)
            # plt.plot(x, y, 'k.', markersize=5)
            plt.imshow(imgt)
        else:
            # 其他情况进行高斯滤波
            img, extent = myplot(x, y, s)
            # img = cv2.flip(img, 0) # 水平翻折
            # img = cv2.resize(img, (512, 512))
            print(img[0][0])
            # img = np.array(img, dtype=np.uint8)
            print(img[0][0])
            print(img.shape)
            print(type(img))
            # backtorgb = cv2.cvtColor(img,cv2.COLOR_GRAY2RGB)
            # image = cv2.addWeighted(image, 1, img, 0.5, 0)
            # image = cv2.addWeighted(image, alpha, zeros_mask, beta, gamma)
            if s != 64:
                plt.subplot(2, 2, int(s/16)+1)
            else:
                plt.subplot(2, 2, int(s/16))
            plt.imshow(img, cmap=cm.jet)
            # plt.savefig(str(int(s/16)+1) + ".png")
    plt.show()

# put_mask(img_path = 'video0/5.png')
# visual_different_people_gaze_data()
# all_gaze_data_to_one()
# gazepath()
heatmap_gaussian()


