import numpy as np
from mayavi import mlab

def load_obj(filename):
    vertices_ = []
    faces_ = []
    for line in open(filename):
        if len(line) == 0:
            continue
        if line.startswith('#'):
            continue
        values = line.split(' ')
        if values[0] == 'v':
            v = [float(x) for x in values[1:4]]
            v = [v[0], v[1], v[2]]
            vertices_.append(v)
        elif values[0] == 'f':
            f = [int(values[1].split('/')[0])-1,
                 int(values[2].split('/')[0])-1,
                 int(values[3].split('/')[0])-1]
            faces_.append(f)
    vertices_ = np.array(vertices_)
    faces_ = np.array(faces_)
    return vertices_, faces_

def mayavi_model(vertices, faces, cell_data_custom):
    # cell_data_custom = [0.1 for i in range(99328)]
    mesh = mlab.triangular_mesh(vertices[:, 0], vertices[:, 1], vertices[:, 2],
                                faces)
    cell_data = mesh.mlab_source.dataset.cell_data
    cell_data.scalars = cell_data_custom
    cell_data.scalars.name = "cell data"
    cell_data.update()
    mesh2 = mlab.pipeline.set_active_attribute(mesh, cell_scalars='cell data')
    mlab.pipeline.surface(mesh2)
    mlab.show()
    return vertices, faces


bunny_path = "E:\\zhangya\\Pro\\textured_mesh_saliency\\fixation\\3DModels-Simplif\\bunny.obj"
vertices, faces = load_obj(bunny_path)

mesh = mlab.triangular_mesh(vertices[:, 0], vertices[:, 1], vertices[:, 2],
                            faces, colormap="winter")
mlab.show()

# mayavi_model(vertices, faces, face_color)

